import const

def inside(x, y, x1, y1, x2, y2):
    return (x >= x1 and x < x2 and y >= y1 and y < y2)

def inside_board(x, y):
    return inside(x, y, const.BOARD_START_X, const.BOARD_START_Y,
                  const.BOARD_END_X, const.BOARD_END_Y)

def inside_board_and_top(x, y):
    return inside(x, y, const.BOARD_START_X, const.BOARD_START_Y,
                  const.BOARD_END_X, const.HEIGHT)

def inside_sprite_box(x, y, sprite):
    sx = sprite.x - sprite.image.anchor_x
    sy = sprite.y - sprite.image.anchor_y
    return inside(x, y, sx, sy, sx + sprite.width, sy + sprite.height)

def board_tile(x, y):
    return [int((int(x) - const.BOARD_START_X)/const.TILE_SIZE),
            int((int(y) - const.BOARD_START_Y)/const.TILE_SIZE)]

def in_board(pos):
    return pos[0] >= 0 and pos[0] < 8 and pos[1] >= 0 and pos[1] < 8

def hit(sprite, x, y):
    sx = sprite.x - sprite.image.anchor_x
    sy = sprite.y - sprite.image.anchor_y
    return (x >= sx and x < sx + sprite.width and
            y >= sy and y < sy + sprite.height)

def hit_sprite(sprite1, sprite2):
    s1x = sprite1.x - sprite1.image.anchor_x
    s2x = sprite2.x - sprite2.image.anchor_x
    s1y = sprite1.y - sprite1.image.anchor_y
    s2y = sprite2.y - sprite2.image.anchor_y
    return (not (s1x > s2x + sprite2.width or
                 s1x + sprite1.width < s2x or
                 s1y + sprite1.height < s2y or
                 s1y > s2y + sprite2.height))

def hit_sprite_h2(sprite1, sprite2):
    s1x = sprite1.x - sprite1.image.anchor_x
    s2x = sprite2.x - sprite2.image.anchor_x
    s1y = sprite1.y - sprite1.image.anchor_y
    s2y = sprite2.y - sprite2.image.anchor_y
    return (not (s1x > s2x + sprite2.width or
                 s1x + sprite1.width < s2x or
                 s1y + sprite1.height / 2 < s2y or
                 s1y > s2y + sprite2.height / 2))
